Index: palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1)
+++ palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 1)
@@ -0,0 +1,92 @@
+ SUBROUTINE calc_liquid_water_content
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: calc_liquid_water_content.f90,v $
+! Revision 1.5  2005/03/26 15:22:06  raasch
+! Arguments for non-cyclic boundary conditions added to argument list of
+! routine exchange_horiz,
+! ql calculated for the ghost points, exchange of ghost points removed
+!
+! Revision 1.4  2004/01/30 10:15:13  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.3  2001/01/22 05:30:59  raasch
+! Module test_variables removed
+!
+! Revision 1.2  2000/06/13 07:49:32  schroeter
+! Horizontal boundary conditions (cyclic) of ql will be set now
+!
+! Revision 1.1  2000/04/13 14:50:45  schroeter
+! Initial revision
+!
+!
+!
+! Description:
+! ------------
+! Calculation of the liquid water content (0%-or-100%-scheme)
+!------------------------------------------------------------------------------!
+
+
+    USE arrays_3d
+    USE cloud_parameters
+    USE constants
+    USE grid_variables
+    USE indices
+    USE pegrid
+
+    IMPLICIT NONE
+
+    INTEGER :: i, j, k
+
+    REAL :: alpha, e_s, q_s, t_l
+
+    DO  i = nxl-1, nxr+1
+       DO  j = nys-1, nyn+1
+          DO  k = nzb_2d(j,i)+1, nzt
+
+!
+!--          Compute the liquid water temperature
+             t_l = t_d_pt(k) * pt(k,j,i)
+
+!
+!--          Compute saturation water vapor pressure at t_l
+             e_s = 610.78 * EXP( 17.269 * ( t_l - 273.16 ) / &
+                                          ( t_l - 35.86 ) )
+
+!
+!--          Compute approximation of saturation humidity
+             q_s = 0.622 * e_s / &
+                   ( hydro_press(k) - 0.378 * e_s )
+
+!
+!--          Correction factor
+             alpha = 0.622 * l_d_r * l_d_cp / ( t_l * t_l )
+
+!
+!--          Correction of the approximated value
+!--          (see: Cuijpers + Duynkerke, 1993, JAS, 23)
+             q_s = q_s * ( 1.0 + alpha * q(k,j,i) ) / ( 1.0 + alpha * q_s )
+
+!
+!--          Compute the liquid water content
+             IF ( ( q(k,j,i) - q_s ) > 0.0 ) THEN
+                ql(k,j,i) = q(k,j,i) - q_s
+             ELSE
+                ql(k,j,i) = 0.0 
+             ENDIF
+
+          ENDDO
+       ENDDO
+    ENDDO
+    
+!
+!-- Setting boundary values of ql
+!    CALL exchange_horiz( ql, 0, 0 )    
+
+ END SUBROUTINE calc_liquid_water_content
Index: palm/trunk/SOURCE/calc_precipitation.f90
===================================================================
--- palm/trunk/SOURCE/calc_precipitation.f90	(revision 1)
+++ palm/trunk/SOURCE/calc_precipitation.f90	(revision 1)
@@ -0,0 +1,112 @@
+ MODULE calc_precipitation_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: calc_precipitation.f90,v $
+! Revision 1.5  2004/01/30 10:15:57  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.4  2003/03/12 16:21:23  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.3  2002/06/11 12:38:58  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.2  2001/01/22 05:32:25  raasch
+! Module test_variables removed
+!
+! Revision 1.1  2000/04/13 14:45:22  schroeter
+! Initial revision
+!
+!
+!
+! Description:
+! ------------
+! Calculate the change of total water content due to precipitation
+! (simplified Kessler scheme)
+!------------------------------------------------------------------------------!
+
+    PRIVATE
+    PUBLIC calc_precipitation
+
+    INTERFACE calc_precipitation
+       MODULE PROCEDURE calc_precipitation
+       MODULE PROCEDURE calc_precipitation_ij
+    END INTERFACE calc_precipitation
+ 
+ CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_precipitation
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE constants
+       USE indices
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+       REAL    :: precipitation_rate
+
+ 
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_2d(j,i)+1, nzt-1    
+
+                IF ( ql(k,j,i) > ql_crit )  THEN
+                   precipitation_rate = prec_time_const * &
+                                        ( ql(k,j,i) - ql_crit )
+                ELSE
+                   precipitation_rate = 0.0
+                ENDIF
+                tend(k,j,i) = tend(k,j,i) - precipitation_rate
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE calc_precipitation
+
+
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_precipitation_ij( i, j )
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE constants
+       USE indices
+   
+       IMPLICIT NONE
+
+       INTEGER :: i, j, k
+       REAL    :: precipitation_rate
+
+
+       DO  k = nzb_2d(j,i)+1, nzt-1    
+
+          IF ( ql(k,j,i) > ql_crit )  THEN
+             precipitation_rate = prec_time_const * ( ql(k,j,i) - ql_crit )
+          ELSE
+             precipitation_rate = 0.0
+          ENDIF
+          tend(k,j,i) = tend(k,j,i) - precipitation_rate
+
+       ENDDO
+
+    END SUBROUTINE calc_precipitation_ij
+
+ END MODULE calc_precipitation_mod
Index: palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- palm/trunk/SOURCE/calc_radiation.f90	(revision 1)
+++ palm/trunk/SOURCE/calc_radiation.f90	(revision 1)
@@ -0,0 +1,284 @@
+ MODULE calc_radiation_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: calc_radiation.f90,v $
+! Revision 1.6  2004/01/30 10:17:03  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.5  2003/03/12 16:21:56  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.4  2002/06/11 12:40:33  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+! 1D-arrays lwp_groud,... are only allocated once in the first call.
+!
+! Revision 1.3  2001/03/30 06:55:27  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.2  2001/01/22 05:35:05  raasch
+! Module test_variables removed
+!
+! Revision 1.1  2000/04/13 14:42:45  schroeter
+! Initial revision
+!
+!
+! Description:
+! -------------
+! Calculation of the vertical divergences of the long-wave radiation-fluxes
+! based on the parameterization of the cloud effective emissivity
+!------------------------------------------------------------------------------!
+
+    PRIVATE
+    PUBLIC calc_radiation
+    
+    LOGICAL, SAVE ::  first_call = .TRUE.
+    REAL, SAVE    ::  sigma = 5.67E-08
+
+    REAL, DIMENSION(:), ALLOCATABLE, SAVE ::  lwp_ground, lwp_top, &
+                                              blackbody_emission
+
+    INTERFACE calc_radiation
+       MODULE PROCEDURE calc_radiation
+       MODULE PROCEDURE calc_radiation_ij
+    END INTERFACE calc_radiation
+ 
+ CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_radiation
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
+       USE indices
+       USE pegrid
+
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k, k_help
+ 
+       REAL :: df_p, df_m , effective_emission_up_m, effective_emission_up_p, &
+               effective_emission_down_m, effective_emission_down_p,          &
+               f_up_m, f_up_p, f_down_m, f_down_p, impinging_flux_at_top,     &
+               temperature
+
+
+!
+!--    On first call, allocate temporary arrays
+       IF ( first_call )  THEN
+          ALLOCATE( blackbody_emission(nzb:nzt+1), lwp_ground(nzb:nzt+1), &
+                    lwp_top(nzb:nzt+1) )
+          first_call = .FALSE.
+       ENDIF
+
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+!
+!--          Compute the liquid water path (LWP) and blackbody_emission
+!--          at all vertical levels
+             lwp_ground(nzb) = 0.0
+             lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
+
+             temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
+             blackbody_emission(nzb) = sigma * temperature**4.0
+
+             DO  k = nzb_2d(j,i)+1, nzt
+
+                k_help = ( nzt+nzb+1 ) - k
+                lwp_ground(k)   = lwp_ground(k-1) + rho_surface * ql(k,j,i) * &
+                                  dzw(k)
+
+                lwp_top(k_help) = lwp_top(k_help+1) + &
+                                  rho_surface * ql(k_help,j,i) * dzw(k_help)
+
+                temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
+                blackbody_emission(k) = sigma * temperature**4.0
+
+             ENDDO
+
+             lwp_ground(nzt+1) = lwp_ground(nzt) + &
+                                 rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
+             lwp_top(nzb)      = lwp_top(nzb+1)
+
+             temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp * &
+                                 ql(nzt+1,j,i)
+             blackbody_emission(nzt+1) = sigma * temperature**4.0
+
+!
+!--          See Chlond '92, this is just a first guess
+             impinging_flux_at_top = blackbody_emission(nzb) - 100.0
+
+             DO  k = nzb_2d(j,i)+1, nzt
+!
+!--             Save some computational time, but this may cause load
+!--             imbalances if ql is not distributed uniformly
+                IF ( ql(k,j,i) /= 0.0 ) THEN
+!
+!--                Compute effective emissivities
+                   effective_emission_up_p   = 1.0 - &
+                                               EXP( -130.0 * lwp_ground(k+1) )
+                   effective_emission_up_m   = 1.0 - &
+                                               EXP( -130.0 * lwp_ground(k-1) )
+                   effective_emission_down_p = 1.0 - &
+                                               EXP( -158.0 * lwp_top(k+1) )
+                   effective_emission_down_m = 1.0 - &
+                                               EXP( -158.0 * lwp_top(k-1) )  
+
+!
+!--                Compute vertical long wave radiation fluxes
+                   f_up_p = blackbody_emission(nzb) + &
+                            effective_emission_up_p * &
+                           ( blackbody_emission(k) - blackbody_emission(nzb) )
+
+                   f_up_m = blackbody_emission(nzb) + &
+                            effective_emission_up_m * &
+                           ( blackbody_emission(k-1) - blackbody_emission(nzb) )
+
+                   f_down_p = impinging_flux_at_top + &
+                              effective_emission_down_p * &
+                             ( blackbody_emission(k) - impinging_flux_at_top )
+
+                   f_down_m = impinging_flux_at_top + &
+                              effective_emission_down_m * &
+                             ( blackbody_emission(k-1) - impinging_flux_at_top )
+
+!
+!--                Divergence of vertical long wave radiation fluxes
+                   df_p = f_up_p - f_down_p
+                   df_m = f_up_m - f_down_m
+
+!
+!--                Compute tendency term         
+                   tend(k,j,i) = tend(k,j,i) - &
+                                ( pt_d_t(k) / ( rho_surface * cp ) * &
+                                  ( df_p - df_m ) / dzw(k) )
+
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE calc_radiation
+
+
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_radiation_ij( i, j )
+
+       USE arrays_3d
+       USE cloud_parameters
+       USE control_parameters
+       USE indices
+       USE pegrid
+   
+       IMPLICIT NONE
+
+       INTEGER :: i, j, k, k_help
+
+       REAL :: df_p, df_m , effective_emission_up_m, effective_emission_up_p, &
+               effective_emission_down_m, effective_emission_down_p,          &
+               f_up_m, f_up_p, f_down_m, f_down_p, impinging_flux_at_top,     &
+               temperature
+
+!
+!--    On first call, allocate temporary arrays
+       IF ( first_call )  THEN
+          ALLOCATE( blackbody_emission(nzb:nzt+1), lwp_ground(nzb:nzt+1), &
+                    lwp_top(nzb:nzt+1) )
+          first_call = .FALSE.
+       ENDIF
+
+!
+!--    Compute the liquid water path (LWP) and blackbody_emission
+!--    at all vertical levels
+       lwp_ground(nzb) = 0.0
+       lwp_top(nzt+1)  = rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
+
+       temperature     = pt(nzb,j,i) * t_d_pt(nzb) + l_d_cp * ql(nzb,j,i)
+       blackbody_emission(nzb) = sigma * temperature**4.0
+
+       DO  k = nzb_2d(j,i)+1, nzt
+          k_help = ( nzt+nzb+1 ) - k
+          lwp_ground(k)   = lwp_ground(k-1) + rho_surface * ql(k,j,i) * dzw(k)
+
+          lwp_top(k_help) = lwp_top(k_help+1) + &
+                            rho_surface * ql(k_help,j,i) * dzw(k_help)
+
+          temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
+          blackbody_emission(k) = sigma * temperature**4.0
+
+       ENDDO
+       lwp_ground(nzt+1) = lwp_ground(nzt) + &
+                           rho_surface * ql(nzt+1,j,i) * dzw(nzt+1)
+       lwp_top(nzb)      = lwp_top(nzb+1)
+
+       temperature       = pt(nzt+1,j,i) * t_d_pt(nzt+1) + l_d_cp * &
+                           ql(nzt+1,j,i)
+       blackbody_emission(nzt+1) = sigma * temperature**4.0
+
+!
+!--    See Chlond '92, this is just a first guess
+       impinging_flux_at_top = blackbody_emission(nzb) - 100.0
+
+       DO  k = nzb_2d(j,i)+1, nzt
+!
+!--       Store some computational time,
+!--       this may cause load imbalances if ql is not distributed uniformly
+          IF ( ql(k,j,i) /= 0.0 ) THEN
+!
+!--          Compute effective emissivities
+             effective_emission_up_p   = 1.0 - &
+                                         EXP( -130.0 * lwp_ground(k+1) )
+             effective_emission_up_m   = 1.0 - &
+                                         EXP( -130.0 * lwp_ground(k-1) )
+             effective_emission_down_p = 1.0 - &
+                                         EXP( -158.0 * lwp_top(k+1) )
+             effective_emission_down_m = 1.0 - &
+                                         EXP( -158.0 * lwp_top(k-1) )  
+             
+!
+!--          Compute vertical long wave radiation fluxes
+             f_up_p = blackbody_emission(nzb) + effective_emission_up_p * &
+                     ( blackbody_emission(k) - blackbody_emission(nzb) )
+
+             f_up_m = blackbody_emission(nzb) + effective_emission_up_m * &
+                     ( blackbody_emission(k-1) - blackbody_emission(nzb) )
+
+             f_down_p = impinging_flux_at_top + effective_emission_down_p * &
+                       ( blackbody_emission(k) - impinging_flux_at_top )
+
+             f_down_m = impinging_flux_at_top + effective_emission_down_m * &
+                       ( blackbody_emission(k-1) - impinging_flux_at_top )
+
+!
+!-           Divergence of vertical long wave radiation fluxes
+             df_p = f_up_p - f_down_p
+             df_m = f_up_m - f_down_m
+
+!
+!--          Compute tendency term         
+             tend(k,j,i) = tend(k,j,i) - ( pt_d_t(k) / ( rho_surface * cp ) * &
+                                         ( df_p - df_m ) / dzw(k) )
+
+          ENDIF
+
+       ENDDO
+
+    END SUBROUTINE calc_radiation_ij
+
+ END MODULE calc_radiation_mod
Index: palm/trunk/SOURCE/calc_spectra.f90
===================================================================
--- palm/trunk/SOURCE/calc_spectra.f90	(revision 1)
+++ palm/trunk/SOURCE/calc_spectra.f90	(revision 1)
@@ -0,0 +1,444 @@
+ SUBROUTINE calc_spectra
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: calc_spectra.f90,v $
+! Revision 1.9  2006/04/11 14:56:00  raasch
+! pl_spectra renamed data_output_sp
+!
+! Revision 1.8  2005/05/18 15:08:18  raasch
+! n is assigned the number of spectra (formerly, the number of spectra was
+! given by n-1)
+!
+! Revision 1.7  2005/04/23 08:41:39  raasch
+! Abort in case of non-cyclic lateral boundaries
+!
+! Revision 1.6  2004/04/30 08:23:12  raasch
+! Usage of all available FFT-methods is possible, direct transpositions from
+! z to x and from z to y are used, FFT routines renamed, module
+! fft_for_1d_decomp renamed fft_xy, extensions for enlarged subdomain added
+!
+! Revision 1.5  2003/03/16 09:27:35  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.4  2002/06/11 12:44:15  raasch
+! TRIM function added (needed on IBM-systems)
+!
+! Revision 1.3  2001/03/30  06:55:58  06:55:58  raasch (Siegfried Raasch)
+! Work array replaced by tend,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+! 
+! Revision 1.2  2001/01/25 06:52:21  raasch
+! Module singleton moved to modules.f90
+!
+! Revision 1.1  2001/01/05 15:08:07  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Calculate horizontal spectra along x and y. 
+! ATTENTION: 1d-decomposition along y still needs improvement, because in that
+!            case the gridpoint number along z still depends on the PE number
+!            because transpose_xz has to be used (and possibly also
+!            transpose_zyd needs modification).
+!------------------------------------------------------------------------------!
+
+#if defined( __spectra )
+    USE arrays_3d
+    USE control_parameters
+    USE cpulog
+    USE fft_xy
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE spectrum
+
+    IMPLICIT NONE
+
+    INTEGER ::  m, pr
+
+
+    CALL cpu_log( log_point(30), 'calc_spectra', 'start' )
+
+!
+!-- Initialize ffts
+    CALL fft_init
+
+!
+!-- Enlarge the size of tend, used as a working array for the transpositions
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(1:nza,nys:nyna,nxl:nxra) )
+    ENDIF
+
+    m = 1
+    DO WHILE ( data_output_sp(m) /= ' '  .AND.  m <= 10 )
+!
+!--    Transposition from z --> x  ( y --> x in case of a 1d-decomposition
+!--    along x)
+       IF ( INDEX( spectra_direction(m), 'x' ) /= 0 )  THEN
+
+!
+!--       Calculation of spectra works for cyclic boundary conditions only
+          IF ( bc_lr /= 'cyclic' )  THEN
+             IF ( myid == 0 )  THEN
+                PRINT*, '+++ calc_spectra:'
+                PRINT*, '    non-cyclic lateral boundaries along x do not ', &
+                             'allow calculation of spectra along x' 
+             ENDIF
+             CALL local_stop
+          ENDIF
+
+          CALL preprocess_spectra( m, pr )
+
+#if defined( __parallel )
+          IF ( pdims(2) /= 1 )  THEN
+             CALL transpose_zx( d, tend, d, tend, d )
+          ELSE
+             CALL transpose_yxd( d, tend, d, tend, d )
+          ENDIF
+          CALL calc_spectra_x( d, pr, m )
+#else
+          PRINT*, '+++ calc_spectra: sorry, calculation of spectra ', &
+                                    'in non parallel mode'
+          PRINT*, '                  is still not realized'
+          CALL local_stop
+#endif
+
+       ENDIF
+
+!
+!--    Transposition from z --> y (d is rearranged only in case of a
+!--    1d-decomposition along x)
+       IF ( INDEX( spectra_direction(m), 'y' ) /= 0 )  THEN
+
+!
+!--       Calculation of spectra works for cyclic boundary conditions only
+          IF ( bc_ns /= 'cyclic' )  THEN
+             IF ( myid == 0 )  THEN
+                PRINT*, '+++ calc_spectra:'
+                PRINT*, '    non-cyclic lateral boundaries along y do not ', &
+                             'allow calculation of spectra along y' 
+             ENDIF
+             CALL local_stop
+          ENDIF
+
+          CALL preprocess_spectra( m, pr )
+
+#if defined( __parallel )
+          CALL transpose_zyd( d, tend, d, tend, d )
+          CALL calc_spectra_y( d, pr, m )
+#else
+          PRINT*, '+++ calc_spectra: sorry, calculation of spectra', &
+                                    'in non parallel mode'
+          PRINT*, '                  still not realized'
+          CALL local_stop
+#endif
+
+       ENDIF
+
+!
+!--    Increase counter for next spectrum
+       m = m + 1
+          
+    ENDDO
+
+!
+!-- Increase counter for averaging process in routine plot_spectra
+    average_count_sp = average_count_sp + 1
+
+!
+!-- Resize tend to its normal size
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ENDIF
+
+    CALL cpu_log( log_point(30), 'calc_spectra', 'stop' )
+
+#endif
+ END SUBROUTINE calc_spectra
+
+
+#if defined( __spectra )
+ SUBROUTINE preprocess_spectra( m, pr )
+
+    USE arrays_3d
+    USE indices
+    USE pegrid
+    USE spectrum
+    USE statistics
+
+    IMPLICIT NONE
+
+    INTEGER :: i, j, k, m, pr
+
+    SELECT CASE ( TRIM( data_output_sp(m) ) )
+          
+    CASE ( 'u' )
+       pr = 1
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = u(nzb+1:nzt,nys:nyn,nxl:nxr)
+       
+    CASE ( 'v' )
+       pr = 2
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = v(nzb+1:nzt,nys:nyn,nxl:nxr)
+       
+    CASE ( 'w' )
+       pr = 3
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = w(nzb+1:nzt,nys:nyn,nxl:nxr)
+       
+    CASE ( 'pt' )
+       pr = 4
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = pt(nzb+1:nzt,nys:nyn,nxl:nxr)
+       
+    CASE ( 'q' )
+       pr = 41
+       d(nzb+1:nzt,nys:nyn,nxl:nxr) = q(nzb+1:nzt,nys:nyn,nxl:nxr)
+       
+    CASE DEFAULT
+       PRINT*, '+++ preprocess_spectra: Spectra of ', &
+               TRIM( data_output_sp(m) ), ' can not be calculated'
+          
+    END SELECT
+
+!
+!-- Subtract horizontal mean from the array, for which spectra have to be
+!-- calculated
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) = d(k,j,i) - sums(k,pr)
+          ENDDO
+       ENDDO
+    ENDDO
+
+ END SUBROUTINE preprocess_spectra
+
+
+ SUBROUTINE calc_spectra_x( ddd, pr, m )
+
+    USE arrays_3d
+    USE constants
+    USE control_parameters
+    USE fft_xy
+    USE grid_variables
+    USE indices
+    USE pegrid
+    USE spectrum
+    USE statistics
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER                    ::  i, ishape(1), j, k, m, n, pr
+
+    REAL                       ::  fac, exponent
+    REAL, DIMENSION(0:nx)      ::  work
+    REAL, DIMENSION(0:nx/2)    ::  sums_spectra_l
+    REAL, DIMENSION(0:nx/2,10) ::  sums_spectra
+
+    REAL, DIMENSION(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa) ::  ddd
+
+!
+!-- Exponent for geometric average
+    exponent = 1.0 / ( nx + 1.0 )
+
+!
+!-- Loop over all levels defined by the user
+    n = 1
+    DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 10 )
+
+       k = comp_spectra_level(n)
+
+!
+!--    Calculate FFT only if the corresponding level is situated on this PE
+       IF ( k >= nzb_x  .AND.  k <= nzt_x )  THEN
+          
+          DO  j = nys_x, nyn_x
+
+             work = ddd(0:nx,j,k)
+             CALL fft_x( work, 'forward' )
+
+             ddd(0,j,k) = dx * work(0)**2
+             DO  i = 1, nx/2
+                ddd(i,j,k) = dx * ( work(i)**2 + work(nx+1-i)**2 )
+             ENDDO
+
+          ENDDO
+
+!
+!--       Local sum and geometric average of these spectra
+!--       (WARNING: no global sum should be performed, because floating
+!--       point overflow may occur)
+          DO  i = 0, nx/2
+
+             sums_spectra_l(i) = 1.0
+             DO  j = nys_x, nyn_x
+                sums_spectra_l(i) = sums_spectra_l(i) * ddd(i,j,k)**exponent
+             ENDDO
+
+          ENDDO
+          
+       ELSE
+
+          sums_spectra_l = 1.0
+
+       ENDIF
+
+!
+!--    Global sum of spectra on PE0 (from where they are written on file) 
+       sums_spectra(:,n) = 0.0
+#if defined( __parallel )   
+       CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
+       CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), nx/2+1, &
+                        MPI_REAL, MPI_PROD, 0, comm2d, ierr )
+#else
+       sums_spectra(:,n) = sums_spectra_l
+#endif
+
+       n = n + 1
+
+    ENDDO
+    n = n - 1
+
+    IF ( myid == 0 )  THEN
+!
+!--    Sum of spectra for later averaging (see routine plot_spectra)
+!--    Temperton fft results need to be normalized
+       IF ( fft_method == 'temperton-algorithm' )  THEN
+          fac = nx + 1.0
+       ELSE
+          fac = 1.0
+       ENDIF
+       DO  i = 1, nx/2
+          DO k = 1, n
+             spectrum_x(i,k,m) = spectrum_x(i,k,m) + sums_spectra(i,k) * fac
+          ENDDO
+       ENDDO
+
+    ENDIF
+
+!
+!-- n_sp_x is needed by plot_spectra_x
+    n_sp_x = n
+
+ END SUBROUTINE calc_spectra_x
+
+
+ SUBROUTINE calc_spectra_y( ddd, pr, m )
+
+    USE arrays_3d
+    USE constants
+    USE control_parameters
+    USE fft_xy
+    USE grid_variables
+    USE indices
+    USE pegrid
+    USE spectrum
+    USE statistics
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER :: i, j, jshape(1), k, m, n, pr
+
+    REAL                       ::  fac, exponent
+    REAL, DIMENSION(0:ny)      ::  work
+    REAL, DIMENSION(0:ny/2)    ::  sums_spectra_l
+    REAL, DIMENSION(0:ny/2,10) ::  sums_spectra
+
+    REAL, DIMENSION(0:nya,nxl_yd:nxr_yda,nzb_yd:nzt_yda) :: ddd
+
+
+!
+!-- Exponent for geometric average
+    exponent = 1.0 / ( nx + 1.0 )
+
+!
+!-- Loop over all levels defined by the user
+    n = 1
+    DO WHILE ( comp_spectra_level(n) /= 999999  .AND.  n <= 10 )
+
+       k = comp_spectra_level(n)
+
+!
+!--    Calculate FFT only if the corresponding level is situated on this PE
+       IF ( k >= nzb_yd  .AND.  k <= nzt_yd )  THEN
+          
+          DO  i = nxl_yd, nxr_yd
+
+             work = ddd(0:ny,i,k)
+             CALL fft_y( work, 'forward' )
+
+             ddd(0,i,k) = dy * work(0)**2
+             DO  j = 1, ny/2
+                ddd(j,i,k) = dy * ( work(j)**2 + work(ny+1-j)**2 )
+             ENDDO
+
+          ENDDO
+
+!
+!--       Local sum and geometric average of these spectra
+!--       (WARNING: no global sum should be performed, because floating
+!--       point overflow may occur)
+          DO  j = 0, ny/2
+
+             sums_spectra_l(j) = 1.0
+             DO  i = nxl_yd, nxr_yd
+                sums_spectra_l(j) = sums_spectra_l(j) * ddd(j,i,k)**exponent
+             ENDDO
+
+          ENDDO
+          
+       ELSE
+
+          sums_spectra_l = 1.0
+
+       ENDIF
+
+!
+!--    Global sum of spectra on PE0 (from where they are written on file) 
+       sums_spectra(:,n) = 0.0
+#if defined( __parallel )   
+       CALL MPI_BARRIER( comm2d, ierr )  ! Necessary?
+       CALL MPI_REDUCE( sums_spectra_l(0), sums_spectra(0,n), ny/2+1, &
+                        MPI_REAL, MPI_PROD, 0, comm2d, ierr )
+#else
+       sums_spectra(:,n) = sums_spectra_l
+#endif
+
+       n = n + 1
+
+    ENDDO
+    n = n - 1
+
+
+    IF ( myid == 0 )  THEN
+!
+!--    Sum of spectra for later averaging (see routine plot_spectra)
+!--    Temperton fft results need to be normalized
+       IF ( fft_method == 'temperton-algorithm' )  THEN
+          fac = ny + 1.0
+       ELSE
+          fac = 1.0
+       ENDIF
+       DO  j = 1, ny/2
+          DO k = 1, n
+             spectrum_y(j,k,m) = spectrum_y(j,k,m) + sums_spectra(j,k) * fac
+          ENDDO
+       ENDDO
+
+    ENDIF
+
+!
+!-- n_sp_y is needed by plot_spectra_y
+    n_sp_y = n
+
+ END SUBROUTINE calc_spectra_y
+#endif
